; demonstrate a 'hidable spectrum';
; it can be revealed by clicking an expansion button

(use-modules (gnome gtk)
	     (spectrum)
	     (spec-extra))

(define spec-hsqc (spectrum-nih-2d-from-file "data/hsqc.DAT"))
(define thres 5.5)

(define canv (make <hos-canvas>
	       #:width-request 300	
	       #:height-request 300))
(canvas-set-spectrum canv spec-hsqc)
(set-to-purple (canvas-get-painter canv))
(painter-set-thres (canvas-get-painter canv) thres)

(define canv-red (make <hos-canvas>
		   #:width-request 300	
		   #:height-request 300))
(canvas-set-spectrum canv-red spec-hsqc)
(set-to-reddish (canvas-get-painter canv-red))
(painter-set-thres (canvas-get-painter canv-red) thres)

(define expander (make <gtk-expander> #:label "hsqc"))
(add expander canv)

(define expander-red (make <gtk-expander> #:label "hsqc (in red)"))
(add expander-red canv-red)

(define main-window (make <gtk-window> #:title "expandable spectrum"))
(define vbox (make <gtk-vbox>))

(pack-start vbox expander #f #f 5)
(pack-start vbox expander-red #f #f 5)

(add main-window vbox)

(show-all main-window)
(connect main-window 'destroy (lambda args (gtk-main-quit)))
(gtk-main)



