; demonstrate a spectrum in a viewport, making it scrollable
; and zoomable.

(use-modules (gnome gtk)
	     (spectrum)
	     (spec-extra))

(define spec-hsqc (spectrum-nih-2d-from-file "data/hsqc.DAT"))
(define thres 6.0)

(define canv (make <hos-canvas>
	       #:width-request 3000	
	       #:height-request 3000))
(canvas-set-spectrum canv spec-hsqc)
(set-to-purple (canvas-get-painter canv))
(painter-set-thres (canvas-get-painter canv) thres)

;; works for both guile-1.6 and guile-1.8
(define (floor->exact x)
  (inexact->exact (round x)))

(define (zoom-by factor)
  (let* ((allocation (gtk-widget-get-allocation canv))
	 (width (vector-ref allocation 2))
	 (height (vector-ref allocation 3)))
    (gtk-widget-set-size-request canv (floor->exact (* width factor))(floor->exact (* height factor)))))

(define hbox (make <gtk-hbox>))
(define zoom-in-button (make <gtk-button> #:label "+"))
(define zoom-out-button (make <gtk-button> #:label "-"))
(pack-start hbox zoom-in-button #f #f 5)
(pack-start hbox zoom-out-button #f #f 5)

(connect canv 'clicked
	 (lambda args
	   #f))

(define main-window (make <gtk-window> #:title "expandable spectrum"))
(define vbox (make <gtk-vbox>))
(define sw (make <gtk-scrolled-window>))
(gtk-scrolled-window-add-with-viewport sw canv)
(pack-start vbox hbox #f #f 5)
(pack-start vbox sw #t #t 0)
(add main-window vbox)

(define (reciprocal x)(/ 1.0 x))
(define zoom-factor 1.2)

(connect zoom-in-button 'clicked (lambda (b)(zoom-by zoom-factor) #f))
(connect zoom-out-button 'clicked (lambda (b)(zoom-by (reciprocal zoom-factor)) #f))

(show-all main-window)
(connect main-window 'destroy (lambda args (gtk-main-quit)))
(gtk-main)



